#include "C:\\Documents and Settings\\Alexandr\\My Documents\\Visual Studio 2005\\Projects\\zx\\zx\\z80ex-0.15\\include\\z80ex.h" 

int colors[0x10] = {
	RGB(  0,   0,   0),
	RGB(  0,   0, 128),
	RGB(128,   0,   0),
	RGB(128,   0, 128),
	RGB(  0, 128,   0),
	RGB(  0, 128, 128),
	RGB(128, 128,   0),
	RGB(128, 128, 128),
	RGB(  0,   0,   0),
	RGB(  0,   0, 255),
	RGB(255,   0,   0),
	RGB(255,   0, 255),
	RGB(  0, 255,   0),
	RGB(  0, 255, 255),
	RGB(255, 255,   0),
	RGB(255, 255, 255)
};

unsigned short native_colors[0x10];

static unsigned char* memory;

class CSpeccy
{
private:
  Z80EX_CONTEXT* cpu; 
public:
	CSpeccy()
	{
		memory = new unsigned char[65536];
		HANDLE hFile = CreateFile(_T("c:\\48.rom"), GENERIC_READ, 0, 0, OPEN_EXISTING, 0,0);
		//HANDLE hFile = CreateFileW(_T("\\LOOXStore\\Backup.bin"), GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,0);
		//HANDLE hFile = CreateFileW(_T("\\Storage card\\Backup.bin"), GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,0);
		//FILE* f = fopen("\\LOOXstore\\backup.bin", "r+");
		//int t = GetLastError();
		//fread(memory, 16384, 16384, f);

		//HANDLE hFile = CreateFile(_T("d:\\scr.bin"), GENERIC_READ, 0, 0, OPEN_EXISTING, 0,0);
		DWORD br;
		ReadFile(hFile, memory, 16384, &br, 0);
		//ReadFile(hFile, &(rombuf[16384]), 6912, &br, 0);
		CloseHandle(hFile);
		cpu = z80ex_create(&CSpeccy::ReadByte, NULL, &CSpeccy::WriteByte, NULL,	&CSpeccy::InputByte, NULL, &CSpeccy::OutputByte, NULL, &CSpeccy::ReadIntVec, NULL); 

		for (char i=0;i<0x10;i++)
			native_colors[i] = gd565::ColorrefToNative(colors[i]);

		z80ex_reset(cpu);
	}

	int Step()
	{
		return z80ex_step(cpu);
	}

	void DrawScreen(GDBUFFERDESC* gdbd)
	{
		unsigned short* gpntr = (unsigned short*)gdbd->pBuffer;

		unsigned short* nextAddr = gpntr + gdbd->dwWidth;
		unsigned short ci, cp;

		for (int y=0;y<192;y++)
		{
			int x = 0;
			unsigned int addr = 0x4000 + ((y & 0xC0) << 5) + ((y & 7) << 8) + ((y & 0x38) << 2); 
			for (int p=0;p<32;p++)
			{
				unsigned char tmp = memory[addr];
				unsigned char cl = memory[ 0x4000 + 0x1800 + ((y & 0xF8) << 2) + p ];

				if (cl&128)
				{
					cp = native_colors[((cl & 64) >> 3) | (cl & 7)];
					ci = native_colors[((cl & 64) >> 3) | ((cl >> 3) & 7)];
				}
				else
				{
					ci = native_colors[((cl & 64) >> 3) | (cl & 7)];
					cp = native_colors[((cl & 64) >> 3) | ((cl >> 3) & 7)];
				} 

				*gpntr++ = (tmp & 128 ? ci : cp);
				*gpntr++ = (tmp & 64 ? ci : cp);
				*gpntr++ = (tmp & 32 ? ci : cp);
				*gpntr++ = (tmp & 16 ? ci : cp);
				*gpntr++ = (tmp & 8 ? ci : cp);
				*gpntr++ = (tmp & 4 ? ci : cp);
				*gpntr++ = (tmp & 2 ? ci : cp);
				*gpntr++ = (tmp & 1 ? ci : cp);
				addr++;
			}
			gpntr = nextAddr;
			nextAddr = gpntr + gdbd->dwWidth;
		}	
	}

	void Reset()
	{
		z80ex_reset(cpu);
	}

	static Z80EX_BYTE ReadByte(Z80EX_CONTEXT *cpu, Z80EX_WORD addr, int m1_state, void *userData)
	{
		if (addr>65535)
			return 0xFF;
		else
			return memory[addr];
	}

	static void WriteByte(Z80EX_CONTEXT *cpu, Z80EX_WORD addr, Z80EX_BYTE value, void *userData)
	{
		if (addr>65535)
			return;
		else
			memory[addr] = value;

	}

	static Z80EX_BYTE InputByte(Z80EX_CONTEXT *cpu, Z80EX_WORD port, void *userData)
	{
		if ((port & 0xFF)==0xFE) return 0x00;
		return 0xFF;
	}

	static void OutputByte(Z80EX_CONTEXT *cpu, Z80EX_WORD port, Z80EX_BYTE value, void *userData)
	{
	}



	static Z80EX_BYTE ReadIntVec(Z80EX_CONTEXT *cpu, void *userData)
	{
		return 0xFF;
	}

};